// WARNING: This file was automatically generated. Do not edit it directly,
//          or you will lose your changes.
/*
 *  Licensed to the Apache Software Foundation (ASF) under one
 *  or more contributor license agreements.  See the NOTICE file
 *  distributed with this work for additional information
 *  regarding copyright ownership.  The ASF licenses this file
 *  to you under the Apache License, Version 2.0 (the
 *  "License"); you may not use this file except in compliance
 *  with the License.  You may obtain a copy of the License at
 * 
 *  http://www.apache.org/licenses/LICENSE-2.0
 * 
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 */
package org.apache.myfaces.commons.converter;

import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.webapp.UIComponentTag;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import java.util.Locale;


public class TypedNumberConverterTag
    extends org.apache.myfaces.commons.converter.ConverterBaseTag
{

    public TypedNumberConverterTag()
    {
        setConverterId("org.apache.myfaces.custom.convertNumber.TypedNumberConverter");
    }
 
    private String _destType;
    
    public void setDestType(String destType)
    {
        _destType = destType;
    }
 
    private String _currencyCode;
    
    public void setCurrencyCode(String currencyCode)
    {
        _currencyCode = currencyCode;
    }
 
    private String _currencySymbol;
    
    public void setCurrencySymbol(String currencySymbol)
    {
        _currencySymbol = currencySymbol;
    }
 
    private String _groupingUsed;
    
    public void setGroupingUsed(String groupingUsed)
    {
        _groupingUsed = groupingUsed;
    }
 
    private String _integerOnly;
    
    public void setIntegerOnly(String integerOnly)
    {
        _integerOnly = integerOnly;
    }
 
    private String _locale;
    
    public void setLocale(String locale)
    {
        _locale = locale;
    }
 
    private String _maxFractionDigits;
    
    public void setMaxFractionDigits(String maxFractionDigits)
    {
        _maxFractionDigits = maxFractionDigits;
    }
 
    private String _maxIntegerDigits;
    
    public void setMaxIntegerDigits(String maxIntegerDigits)
    {
        _maxIntegerDigits = maxIntegerDigits;
    }
 
    private String _minFractionDigits;
    
    public void setMinFractionDigits(String minFractionDigits)
    {
        _minFractionDigits = minFractionDigits;
    }
 
    private String _minIntegerDigits;
    
    public void setMinIntegerDigits(String minIntegerDigits)
    {
        _minIntegerDigits = minIntegerDigits;
    }
 
    private String _pattern;
    
    public void setPattern(String pattern)
    {
        _pattern = pattern;
    }
 
    private String _type;
    
    public void setType(String type)
    {
        _type = type;
    }

    public void setPageContext(PageContext context) {
        super.setPageContext(context);
        setConverterId("org.apache.myfaces.custom.convertNumber.TypedNumberConverter");
    }

    protected Converter createConverter() throws JspException {
    
        FacesContext facesContext = FacesContext.getCurrentInstance();            
        org.apache.myfaces.commons.converter.TypedNumberConverter converter = (org.apache.myfaces.commons.converter.TypedNumberConverter)super.createConverter();
        if (_destType != null)
        {
            if (UIComponentTag.isValueReference(_destType))
            {
                ValueBinding vb = facesContext.getApplication().createValueBinding(_destType);
                converter.setDestType((java.lang.Class) vb.getValue(facesContext));
            }
            else
            {
                try
                {
                    converter.setDestType(
                    org.apache.myfaces.commons.util.ClassUtils.classForName(_destType));
                }
                catch (ClassNotFoundException e)
                {
                    throw new JspException(e);
                }
            }
        }
        if (_currencyCode != null)
        {
            if (UIComponentTag.isValueReference(_currencyCode))
            {
                ValueBinding vb = facesContext.getApplication().createValueBinding(_currencyCode);
                converter.setValueBinding("currencyCode", vb);
            }
            else
            {
                converter.setCurrencyCode(_currencyCode);
            }
        }
        if (_currencySymbol != null)
        {
            if (UIComponentTag.isValueReference(_currencySymbol))
            {
                ValueBinding vb = facesContext.getApplication().createValueBinding(_currencySymbol);
                converter.setValueBinding("currencySymbol", vb);
            }
            else
            {
                converter.setCurrencySymbol(_currencySymbol);
            }
        }
        if (_groupingUsed != null)
        {
            if (UIComponentTag.isValueReference(_groupingUsed))
            {
                ValueBinding vb = facesContext.getApplication().createValueBinding(_groupingUsed);
                converter.setValueBinding("groupingUsed", vb);
            }
            else
            {
                converter.setGroupingUsed(Boolean.valueOf(_groupingUsed).booleanValue());
            }
        }
        if (_integerOnly != null)
        {
            if (UIComponentTag.isValueReference(_integerOnly))
            {
                ValueBinding vb = facesContext.getApplication().createValueBinding(_integerOnly);
                converter.setValueBinding("integerOnly", vb);
            }
            else
            {
                converter.setIntegerOnly(Boolean.valueOf(_integerOnly).booleanValue());
            }
        }
        if (_locale != null)
        {
            if (UIComponentTag.isValueReference(_locale))
            {
                ValueBinding vb = facesContext.getApplication().createValueBinding(_locale);
                converter.setValueBinding("locale", vb);
            }
            else
            {
                converter.setLocale(
                    org.apache.myfaces.commons.util.TagUtils.getLocale(_locale));
            }
        }
        if (_maxFractionDigits != null)
        {
            if (UIComponentTag.isValueReference(_maxFractionDigits))
            {
                ValueBinding vb = facesContext.getApplication().createValueBinding(_maxFractionDigits);
                converter.setValueBinding("maxFractionDigits", vb);
            }
            else
            {
                converter.setMaxFractionDigits(Integer.valueOf(_maxFractionDigits));
            }
        }
        if (_maxIntegerDigits != null)
        {
            if (UIComponentTag.isValueReference(_maxIntegerDigits))
            {
                ValueBinding vb = facesContext.getApplication().createValueBinding(_maxIntegerDigits);
                converter.setValueBinding("maxIntegerDigits", vb);
            }
            else
            {
                converter.setMaxIntegerDigits(Integer.valueOf(_maxIntegerDigits));
            }
        }
        if (_minFractionDigits != null)
        {
            if (UIComponentTag.isValueReference(_minFractionDigits))
            {
                ValueBinding vb = facesContext.getApplication().createValueBinding(_minFractionDigits);
                converter.setValueBinding("minFractionDigits", vb);
            }
            else
            {
                converter.setMinFractionDigits(Integer.valueOf(_minFractionDigits));
            }
        }
        if (_minIntegerDigits != null)
        {
            if (UIComponentTag.isValueReference(_minIntegerDigits))
            {
                ValueBinding vb = facesContext.getApplication().createValueBinding(_minIntegerDigits);
                converter.setValueBinding("minIntegerDigits", vb);
            }
            else
            {
                converter.setMinIntegerDigits(Integer.valueOf(_minIntegerDigits));
            }
        }
        if (_pattern != null)
        {
            if (UIComponentTag.isValueReference(_pattern))
            {
                ValueBinding vb = facesContext.getApplication().createValueBinding(_pattern);
                converter.setValueBinding("pattern", vb);
            }
            else
            {
                converter.setPattern(_pattern);
            }
        }
        if (_type != null)
        {
            if (UIComponentTag.isValueReference(_type))
            {
                ValueBinding vb = facesContext.getApplication().createValueBinding(_type);
                converter.setValueBinding("type", vb);
            }
            else
            {
                converter.setType(_type);
            }
        }
        return converter;
    }

    public void release()
    {
        super.release();
        _destType = null;
        _currencyCode = null;
        _currencySymbol = null;
        _groupingUsed = null;
        _integerOnly = null;
        _locale = null;
        _maxFractionDigits = null;
        _maxIntegerDigits = null;
        _minFractionDigits = null;
        _minIntegerDigits = null;
        _pattern = null;
        _type = null;
    }
}
